Index: cpp/frams/model/similarity/simil_model.cpp
===================================================================
--- cpp/frams/model/similarity/simil_model.cpp	(revision 605)
+++ cpp/frams/model/similarity/simil_model.cpp	(revision 606)
@@ -426,242 +426,242 @@
 void ModelSimil::_PrintDegrees(int i)
 {
-    int j;
-    printf("Organizm %i :", i);
-    printf("\n      ");
-    for (j = 0; j < m_Mod[i]->getPartCount(); j++)
-        printf("%3i ", j);
-    printf("\nInd:  ");
-    for (j = 0; j < m_Mod[i]->getPartCount(); j++)
-        printf("%3i ", (int) m_aDegrees[i][j][0]);
-    printf("\nDeg:  ");
-    for (j = 0; j < m_Mod[i]->getPartCount(); j++)
-        printf("%3i ", (int) m_aDegrees[i][j][1]);
-    printf("\nNIt:  ");
-    for (j = 0; j < m_Mod[i]->getPartCount(); j++)
-        printf("%3i ", (int) m_aDegrees[i][j][2]);
-    printf("\nNeu:  ");
-    for (j = 0; j < m_Mod[i]->getPartCount(); j++)
-        printf("%3i ", (int) m_aDegrees[i][j][3]);
-    printf("\n");
+	int j;
+	printf("Organizm %i :", i);
+	printf("\n      ");
+	for (j = 0; j < m_Mod[i]->getPartCount(); j++)
+		printf("%3i ", j);
+	printf("\nInd:  ");
+	for (j = 0; j < m_Mod[i]->getPartCount(); j++)
+		printf("%3i ", (int)m_aDegrees[i][j][0]);
+	printf("\nDeg:  ");
+	for (j = 0; j < m_Mod[i]->getPartCount(); j++)
+		printf("%3i ", (int)m_aDegrees[i][j][1]);
+	printf("\nNIt:  ");
+	for (j = 0; j < m_Mod[i]->getPartCount(); j++)
+		printf("%3i ", (int)m_aDegrees[i][j][2]);
+	printf("\nNeu:  ");
+	for (j = 0; j < m_Mod[i]->getPartCount(); j++)
+		printf("%3i ", (int)m_aDegrees[i][j][3]);
+	printf("\n");
 }
 
 /** Prints one array of ints. Debug method.
-    @param array Base pointer of the array.
-    @param base First index of the array's element.
-    @param size Number of elements to print.
- */
+	@param array Base pointer of the array.
+	@param base First index of the array's element.
+	@param size Number of elements to print.
+	*/
 void ModelSimil::_PrintArray(int *array, int base, int size)
 {
-    int i;
-    for (i = base; i < base + size; i++)
-    {
-        printf("%i ", array[i]);
-    }
-    printf("\n");
+	int i;
+	for (i = base; i < base + size; i++)
+	{
+		printf("%i ", array[i]);
+	}
+	printf("\n");
 }
 
 void ModelSimil::_PrintArrayDouble(double *array, int base, int size)
 {
-    int i;
-    for (i = base; i < base + size; i++)
-    {
-        printf("%f ", array[i]);
-    }
-    printf("\n");
+	int i;
+	for (i = base; i < base + size; i++)
+	{
+		printf("%f ", array[i]);
+	}
+	printf("\n");
 }
 
 /** Prints one array of parts neighbourhood.
-    @param index of organism
- */
+	@param index of organism
+	*/
 void ModelSimil::_PrintNeighbourhood(int o)
 {
-    assert(m_Neighbours[o] != 0);
-    printf("Neighbourhhod of organism %i\n", o);
-    int size = m_Mod[o]->getPartCount();
-    for (int i = 0; i < size; i++)
-    {
-        for (int j = 0; j < size; j++)
-        {
-            printf("%i ", m_Neighbours[o][i][j]);
-        }
-        printf("\n");
-    }
+	assert(m_Neighbours[o] != 0);
+	printf("Neighbourhhod of organism %i\n", o);
+	int size = m_Mod[o]->getPartCount();
+	for (int i = 0; i < size; i++)
+	{
+		for (int j = 0; j < size; j++)
+		{
+			printf("%i ", m_Neighbours[o][i][j]);
+		}
+		printf("\n");
+	}
 }
 
 /** Creates arrays holding information about organisms' Parts (m_aDegrees) andm_Neigh
-    fills them with initial data (original indices and zeros).
-    Assumptions:
-    - Models (m_Mod) are created and available.
- */
+	fills them with initial data (original indices and zeros).
+	Assumptions:
+	- Models (m_Mod) are created and available.
+	*/
 int ModelSimil::CreatePartInfoTables()
 {
-    // check assumptions about models
-    assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
-    assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
-
-    int i, j, partCount;
-    // utwórz tablice na informacje o stopniach wierzchołków i liczbie neuroitems
-    for (i = 0; i < 2; i++)
-    {
-        partCount = m_Mod[i]->getPartCount();
-        // utworz i wypelnij tablice dla Parts wartosciami poczatkowymi
-        m_aDegrees[i] = new TDN[ partCount ];
-
-        if (isFuzzy)
-        {
-            m_Neighbours[i] = new int*[ partCount ];
-            m_fuzzyNeighb[i] = new float*[ partCount];
-        }
-
-        if (m_aDegrees[i] != NULL && (isFuzzy != 1 || (m_Neighbours[i] != NULL && m_fuzzyNeighb[i] != NULL)))
-        {
-            // wypelnij tablice zgodnie z sensem TDN[0] - orginalny index
-            // TDN[1], TDN[2], TDN[3] - zerami
-            DB(printf("m_aDegrees[%i]: %p\n", i, m_aDegrees[i]);)
-            for (j = 0; j < partCount; j++)
-            {
-                m_aDegrees[i][j][0] = j;
-                m_aDegrees[i][j][1] = 0;
-                m_aDegrees[i][j][2] = 0;
-                m_aDegrees[i][j][3] = 0;
-                m_aDegrees[i][j][4] = 0;
-
-                // sprawdz, czy nie piszemy po jakims szalonym miejscu pamieci
-                assert(m_aDegrees[i][j] != NULL);
-
-                if (isFuzzy)
-                {
-                    m_Neighbours[i][j] = new int[partCount];
-                    for (int k = 0; k < partCount; k++)
-                    {
-                        m_Neighbours[i][j][k] = 0;
-                    }
-
-                    m_fuzzyNeighb[i][j] = new float[fuzzyDepth];
-                    for (int k = 0; k < fuzzyDepth; k++)
-                    {
-                        m_fuzzyNeighb[i][j][k] = 0;
-                    }
-
-                    assert(m_Neighbours[i][j] != NULL);
-                    assert(m_fuzzyNeighb[i][j] != NULL);
-                }
-
-            }
-        }
-        else
-        {
-            DB(printf("ModelSimil::EvaluateDistance - nie ma pamieci na Degrees\n");)
-            return 0;
-        }
-        // utworz tablice dla pozycji 3D Parts (wielkosc tablicy: liczba Parts organizmu)
-        m_aPositions[ i ] = new Pt3D[ m_Mod[i]->getPartCount() ];
-        assert(m_aPositions[ i ] != NULL);
-        // wypelnij tablice OnJoints i Anywhere wartościami początkowymi
-        // OnJoint
-        m_aOnJoint[i][0] = 0;
-        m_aOnJoint[i][1] = 0;
-        m_aOnJoint[i][2] = 0;
-        m_aOnJoint[i][3] = 0;
-        // Anywhere
-        m_aAnywhere[i][0] = 0;
-        m_aAnywhere[i][1] = 0;
-        m_aAnywhere[i][2] = 0;
-        m_aAnywhere[i][3] = 0;
-    }
-    return 1;
+	// check assumptions about models
+	assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
+	assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
+
+	int i, j, partCount;
+	// utwórz tablice na informacje o stopniach wierzchołków i liczbie neuroitems
+	for (i = 0; i < 2; i++)
+	{
+		partCount = m_Mod[i]->getPartCount();
+		// utworz i wypelnij tablice dla Parts wartosciami poczatkowymi
+		m_aDegrees[i] = new TDN[partCount];
+
+		if (isFuzzy)
+		{
+			m_Neighbours[i] = new int*[partCount];
+			m_fuzzyNeighb[i] = new float*[partCount];
+		}
+
+		if (m_aDegrees[i] != NULL && (isFuzzy != 1 || (m_Neighbours[i] != NULL && m_fuzzyNeighb[i] != NULL)))
+		{
+			// wypelnij tablice zgodnie z sensem TDN[0] - orginalny index
+			// TDN[1], TDN[2], TDN[3] - zerami
+			DB(printf("m_aDegrees[%i]: %p\n", i, m_aDegrees[i]);)
+				for (j = 0; j < partCount; j++)
+				{
+				m_aDegrees[i][j][0] = j;
+				m_aDegrees[i][j][1] = 0;
+				m_aDegrees[i][j][2] = 0;
+				m_aDegrees[i][j][3] = 0;
+				m_aDegrees[i][j][4] = 0;
+
+				// sprawdz, czy nie piszemy po jakims szalonym miejscu pamieci
+				assert(m_aDegrees[i][j] != NULL);
+
+				if (isFuzzy)
+				{
+					m_Neighbours[i][j] = new int[partCount];
+					for (int k = 0; k < partCount; k++)
+					{
+						m_Neighbours[i][j][k] = 0;
+					}
+
+					m_fuzzyNeighb[i][j] = new float[fuzzyDepth];
+					for (int k = 0; k < fuzzyDepth; k++)
+					{
+						m_fuzzyNeighb[i][j][k] = 0;
+					}
+
+					assert(m_Neighbours[i][j] != NULL);
+					assert(m_fuzzyNeighb[i][j] != NULL);
+				}
+
+				}
+		}
+		else
+		{
+			DB(printf("ModelSimil::EvaluateDistance - nie ma pamieci na Degrees\n");)
+				return 0;
+		}
+		// utworz tablice dla pozycji 3D Parts (wielkosc tablicy: liczba Parts organizmu)
+		m_aPositions[i] = new Pt3D[m_Mod[i]->getPartCount()];
+		assert(m_aPositions[i] != NULL);
+		// wypelnij tablice OnJoints i Anywhere wartościami początkowymi
+		// OnJoint
+		m_aOnJoint[i][0] = 0;
+		m_aOnJoint[i][1] = 0;
+		m_aOnJoint[i][2] = 0;
+		m_aOnJoint[i][3] = 0;
+		// Anywhere
+		m_aAnywhere[i][0] = 0;
+		m_aAnywhere[i][1] = 0;
+		m_aAnywhere[i][2] = 0;
+		m_aAnywhere[i][3] = 0;
+	}
+	return 1;
 }
 
 /** Computes degrees of Parts of both organisms. Fills in the m_aDegrees arrays
-    with proper information about degrees.
-    Assumptions:
-    - Models (m_Mod) are created and available.
-    - Arrays m_aDegrees are created.
- */
+	with proper information about degrees.
+	Assumptions:
+	- Models (m_Mod) are created and available.
+	- Arrays m_aDegrees are created.
+	*/
 int ModelSimil::CountPartDegrees()
 {
-    // sprawdz zalozenie - o modelach
-    assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
-    assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
-
-    // sprawdz zalozenie - o tablicach
-    assert(m_aDegrees[0] != NULL);
-    assert(m_aDegrees[1] != NULL);
-
-    Part *P1, *P2;
-    int i, j, i1, i2;
-
-    // dla obu stworzen oblicz stopnie wierzcholkow
-    for (i = 0; i < 2; i++)
-    {
-        // dla wszystkich jointow
-        for (j = 0; j < m_Mod[i]->getJointCount(); j++)
-        {
-            // pobierz kolejny Joint
-            Joint *J = m_Mod[i]->getJoint(j);
-            // wez jego konce
-            P1 = J->part1;
-            P2 = J->part2;
-            // znajdz ich indeksy w Modelu (indeksy orginalne)
-            i1 = m_Mod[i]->findPart(P1);
-            i2 = m_Mod[i]->findPart(P2);
-            // zwieksz stopien odpowiednich Parts
-            m_aDegrees[i][i1][DEGREE]++;
-            m_aDegrees[i][i2][DEGREE]++;
-            m_aDegrees[i][i1][FUZZ_DEG]++;
-            m_aDegrees[i][i2][FUZZ_DEG]++;
-            if (isFuzzy)
-            {
-                m_Neighbours[i][i1][i2] = 1;
-                m_Neighbours[i][i2][i1] = 1;
-            }
-        }
-        // dla elementow nie osadzonych na Parts (OnJoint, Anywhere) -
-        // stopnie wierzchołka są już ustalone na zero
-    }
-
-    if (isFuzzy)
-    {
-        CountFuzzyNeighb();
-    }
-
-    return 1;
+	// sprawdz zalozenie - o modelach
+	assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
+	assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
+
+	// sprawdz zalozenie - o tablicach
+	assert(m_aDegrees[0] != NULL);
+	assert(m_aDegrees[1] != NULL);
+
+	Part *P1, *P2;
+	int i, j, i1, i2;
+
+	// dla obu stworzen oblicz stopnie wierzcholkow
+	for (i = 0; i < 2; i++)
+	{
+		// dla wszystkich jointow
+		for (j = 0; j < m_Mod[i]->getJointCount(); j++)
+		{
+			// pobierz kolejny Joint
+			Joint *J = m_Mod[i]->getJoint(j);
+			// wez jego konce
+			P1 = J->part1;
+			P2 = J->part2;
+			// znajdz ich indeksy w Modelu (indeksy orginalne)
+			i1 = m_Mod[i]->findPart(P1);
+			i2 = m_Mod[i]->findPart(P2);
+			// zwieksz stopien odpowiednich Parts
+			m_aDegrees[i][i1][DEGREE]++;
+			m_aDegrees[i][i2][DEGREE]++;
+			m_aDegrees[i][i1][FUZZ_DEG]++;
+			m_aDegrees[i][i2][FUZZ_DEG]++;
+			if (isFuzzy)
+			{
+				m_Neighbours[i][i1][i2] = 1;
+				m_Neighbours[i][i2][i1] = 1;
+			}
+		}
+		// dla elementow nie osadzonych na Parts (OnJoint, Anywhere) -
+		// stopnie wierzchołka są już ustalone na zero
+	}
+
+	if (isFuzzy)
+	{
+		CountFuzzyNeighb();
+	}
+
+	return 1;
 }
 
 void ModelSimil::GetNeighbIndexes(int mod, int partInd, std::vector<int> &indexes)
 {
-    indexes.clear();
-    int i, size = m_Mod[mod]->getPartCount();
-
-    for (i = 0; i < size; i++)
-    {
-        if (m_Neighbours[mod][partInd][i] > 0)
-        {
-            indexes.push_back(i);
-        }
-    }
+	indexes.clear();
+	int i, size = m_Mod[mod]->getPartCount();
+
+	for (i = 0; i < size; i++)
+	{
+		if (m_Neighbours[mod][partInd][i] > 0)
+		{
+			indexes.push_back(i);
+		}
+	}
 }
 
 int cmpFuzzyRows(const void *pa, const void *pb)
 {
-    float **a = (float**) pa;
-    float **b = (float**) pb;
-
-
-    for (int i = 1; i < fuzDepth; i++)
-    {
-        if (a[0][i] > b[0][i])
-        {
-
-            return -1;
-        }
-        if (a[0][i] < b[0][i])
-        {
-
-            return 1;
-        }
-    }
-
-    return 0;
+	float **a = (float**)pa;
+	float **b = (float**)pb;
+
+
+	for (int i = 1; i < fuzDepth; i++)
+	{
+		if (a[0][i] > b[0][i])
+		{
+
+			return -1;
+		}
+		if (a[0][i] < b[0][i])
+		{
+
+			return 1;
+		}
+	}
+
+	return 0;
 }
 
@@ -669,23 +669,23 @@
 void ModelSimil::CheckFuzzyIdentity()
 {
-    int partCount = 0;
-    for (int mod = 0; mod < 2; mod++)
-    {
-        //for subsequent pairs of parts
-        partCount = m_Mod[mod]->getPartCount();
-        m_aDegrees[mod][partCount - 1][FUZZ_DEG] = 0;
-        for (int partInd = (partCount - 2); partInd >= 0; partInd--)
-        {
-            m_aDegrees[mod][partInd][FUZZ_DEG] = m_aDegrees[mod][partInd + 1][FUZZ_DEG];
-            for (int depth = 1; depth < fuzzyDepth; depth++)
-            {
-                if (m_fuzzyNeighb[mod][partInd][depth] != m_fuzzyNeighb[mod][partInd + 1][depth])
-                {
-                    m_aDegrees[mod][partInd][FUZZ_DEG] += 1;
-                    break;
-                }
-            }
-        }
-    }
+	int partCount = 0;
+	for (int mod = 0; mod < 2; mod++)
+	{
+		//for subsequent pairs of parts
+		partCount = m_Mod[mod]->getPartCount();
+		m_aDegrees[mod][partCount - 1][FUZZ_DEG] = 0;
+		for (int partInd = (partCount - 2); partInd >= 0; partInd--)
+		{
+			m_aDegrees[mod][partInd][FUZZ_DEG] = m_aDegrees[mod][partInd + 1][FUZZ_DEG];
+			for (int depth = 1; depth < fuzzyDepth; depth++)
+			{
+				if (m_fuzzyNeighb[mod][partInd][depth] != m_fuzzyNeighb[mod][partInd + 1][depth])
+				{
+					m_aDegrees[mod][partInd][FUZZ_DEG] += 1;
+					break;
+				}
+			}
+		}
+	}
 }
 
@@ -693,9 +693,9 @@
 void ModelSimil::SortFuzzyNeighb()
 {
-    fuzDepth = fuzzyDepth;
-    for (int mod = 0; mod < 2; mod++)
-    {
-        std::qsort(m_fuzzyNeighb[mod], (size_t) m_Mod[mod]->getPartCount(), sizeof (m_fuzzyNeighb[mod][0]), cmpFuzzyRows);
-    }
+	fuzDepth = fuzzyDepth;
+	for (int mod = 0; mod < 2; mod++)
+	{
+		std::qsort(m_fuzzyNeighb[mod], (size_t)m_Mod[mod]->getPartCount(), sizeof(m_fuzzyNeighb[mod][0]), cmpFuzzyRows);
+	}
 }
 
@@ -703,242 +703,242 @@
 void ModelSimil::CountFuzzyNeighb()
 {
-    assert(m_aDegrees[0] != NULL);
-    assert(m_aDegrees[1] != NULL);
-
-    assert(m_Neighbours[0] != NULL);
-    assert(m_Neighbours[1] != NULL);
-
-    assert(m_fuzzyNeighb[0] != NULL);
-    assert(m_fuzzyNeighb[1] != NULL);
-
-    std::vector<int> nIndexes;
-    float newDeg = 0;
-
-    for (int mod = 0; mod < 2; mod++)
-    {
-        int partCount = m_Mod[mod]->getPartCount();
-
-        for (int depth = 0; depth < fuzzyDepth; depth++)
-        {
-            //use first column for storing indices
-            for (int partInd = 0; partInd < partCount; partInd++)
-            {
-                if (depth == 0)
-                {
-                    m_fuzzyNeighb[mod][partInd][depth] = partInd;
-                }
-                else if (depth == 1)
-                {
-                    m_fuzzyNeighb[mod][partInd][depth] = m_aDegrees[mod][partInd][DEGREE];
-                }
-                else
-                {
-                    GetNeighbIndexes(mod, partInd, nIndexes);
+	assert(m_aDegrees[0] != NULL);
+	assert(m_aDegrees[1] != NULL);
+
+	assert(m_Neighbours[0] != NULL);
+	assert(m_Neighbours[1] != NULL);
+
+	assert(m_fuzzyNeighb[0] != NULL);
+	assert(m_fuzzyNeighb[1] != NULL);
+
+	std::vector<int> nIndexes;
+	float newDeg = 0;
+
+	for (int mod = 0; mod < 2; mod++)
+	{
+		int partCount = m_Mod[mod]->getPartCount();
+
+		for (int depth = 0; depth < fuzzyDepth; depth++)
+		{
+			//use first column for storing indices
+			for (int partInd = 0; partInd < partCount; partInd++)
+			{
+				if (depth == 0)
+				{
+					m_fuzzyNeighb[mod][partInd][depth] = partInd;
+				}
+				else if (depth == 1)
+				{
+					m_fuzzyNeighb[mod][partInd][depth] = m_aDegrees[mod][partInd][DEGREE];
+				}
+				else
+				{
+					GetNeighbIndexes(mod, partInd, nIndexes);
 					for (unsigned int k = 0; k < nIndexes.size(); k++)
-                    {
-                        newDeg += m_fuzzyNeighb[mod][nIndexes.at(k)][depth - 1];
-                    }
-                    newDeg /= nIndexes.size();
-                    m_fuzzyNeighb[mod][partInd][depth] = newDeg;
-                    for (int mod = 0; mod < 2; mod++)
-                    {
-                        int partCount = m_Mod[mod]->getPartCount();
-                        for (int i = partCount - 1; i >= 0; i--)
-                        {
-
-                        }
-                    }
-                    newDeg = 0;
-                }
-            }
-        }
-    }
-
-    SortFuzzyNeighb();
+					{
+						newDeg += m_fuzzyNeighb[mod][nIndexes.at(k)][depth - 1];
+					}
+					newDeg /= nIndexes.size();
+					m_fuzzyNeighb[mod][partInd][depth] = newDeg;
+					for (int mod = 0; mod < 2; mod++)
+					{
+						int partCount = m_Mod[mod]->getPartCount();
+						for (int i = partCount - 1; i >= 0; i--)
+						{
+
+						}
+					}
+					newDeg = 0;
+				}
+			}
+		}
+	}
+
+	SortFuzzyNeighb();
 }
 
 /** Gets information about Parts' positions in 3D from models into the arrays
-        m_aPositions.
-    Assumptions:
-    - Models (m_Mod) are created and available.
-    - Arrays m_aPositions are created.
-    @return 1 if success, otherwise 0.
- */
+		m_aPositions.
+		Assumptions:
+		- Models (m_Mod) are created and available.
+		- Arrays m_aPositions are created.
+		@return 1 if success, otherwise 0.
+		*/
 int ModelSimil::GetPartPositions()
 {
-    // sprawdz zalozenie - o modelach
-    assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
-    assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
-
-    // sprawdz zalozenie - o tablicach m_aPositions
-    assert(m_aPositions[0] != NULL);
-    assert(m_aPositions[1] != NULL);
-
-    // dla każdego stworzenia skopiuj informację o polozeniu jego Parts
-    // do tablic m_aPositions
-    Part *pPart;
-    int iMod; // licznik modeli (organizmow)
-    int iPart; // licznik Parts
-    for (iMod = 0; iMod < 2; iMod++)
-    {
-        // dla każdego z modeli iMod
-        for (iPart = 0; iPart < m_Mod[ iMod ]->getPartCount(); iPart++)
-        {
-            // dla każdego iPart organizmu iMod
-            // pobierz tego Part
-            pPart = m_Mod[ iMod ]->getPart(iPart);
-            // zapamietaj jego pozycje 3D w tablicy m_aPositions
-            m_aPositions[ iMod ][ iPart ].x = pPart->p.x;
-            m_aPositions[ iMod ][ iPart ].y = pPart->p.y;
-            m_aPositions[ iMod ][ iPart ].z = pPart->p.z;
-        }
-    }
-
-    return 1;
+	// sprawdz zalozenie - o modelach
+	assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
+	assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
+
+	// sprawdz zalozenie - o tablicach m_aPositions
+	assert(m_aPositions[0] != NULL);
+	assert(m_aPositions[1] != NULL);
+
+	// dla każdego stworzenia skopiuj informację o polozeniu jego Parts
+	// do tablic m_aPositions
+	Part *pPart;
+	int iMod; // licznik modeli (organizmow)
+	int iPart; // licznik Parts
+	for (iMod = 0; iMod < 2; iMod++)
+	{
+		// dla każdego z modeli iMod
+		for (iPart = 0; iPart < m_Mod[iMod]->getPartCount(); iPart++)
+		{
+			// dla każdego iPart organizmu iMod
+			// pobierz tego Part
+			pPart = m_Mod[iMod]->getPart(iPart);
+			// zapamietaj jego pozycje 3D w tablicy m_aPositions
+			m_aPositions[iMod][iPart].x = pPart->p.x;
+			m_aPositions[iMod][iPart].y = pPart->p.y;
+			m_aPositions[iMod][iPart].z = pPart->p.z;
+		}
+	}
+
+	return 1;
 }
 
 /** Computes numbers of neurons and neurons' inputs for each Part of each
-    organisms and fills in the m_aDegrees array.
-    Assumptions:
-    - Models (m_Mod) are created and available.
-    - Arrays m_aDegrees are created.
- */
+	organisms and fills in the m_aDegrees array.
+	Assumptions:
+	- Models (m_Mod) are created and available.
+	- Arrays m_aDegrees are created.
+	*/
 int ModelSimil::CountPartNeurons()
 {
-    // sprawdz zalozenie - o modelach
-    assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
-    assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
-
-    // sprawdz zalozenie - o tablicach
-    assert(m_aDegrees[0] != NULL);
-    assert(m_aDegrees[1] != NULL);
-
-    Part *P1;
-    Joint *J1;
-    int i, j, i2, neuro_connections;
-
-    // dla obu stworzen oblicz liczbe Neurons + connections dla Parts
-    // a takze dla OnJoints i Anywhere
-    for (i = 0; i < 2; i++)
-    {
-        for (j = 0; j < m_Mod[i]->getNeuroCount(); j++)
-        {
-            // pobierz kolejny Neuron
-            Neuro *N = m_Mod[i]->getNeuro(j);
-            // policz liczbe jego wejść i jego samego tez
-            // czy warto w ogole liczyc polaczenia...? co to da/spowoduje?
-            neuro_connections = N->getInputCount() + 1;
-            // wez Part, na ktorym jest Neuron
-            P1 = N->getPart();
-            if (P1)
-            {
-                // dla neuronow osadzonych na Partach
-                i2 = m_Mod[i]->findPart(P1); // znajdz indeks Part w Modelu
-                m_aDegrees[i][i2][2] += neuro_connections; // zwieksz liczbe Connections+Neurons dla tego Part (TDN[2])
-                m_aDegrees[i][i2][3]++; // zwieksz liczbe Neurons dla tego Part (TDN[3])
-            }
-            else
-            {
-                // dla neuronow nie osadzonych na partach
-                J1 = N->getJoint();
-                if (J1)
-                {
-                    // dla tych na Jointach
-                    m_aOnJoint[i][2] += neuro_connections; // zwieksz liczbe Connections+Neurons
-                    m_aOnJoint[i][3]++; // zwieksz liczbe Neurons
-                }
-                else
-                {
-                    // dla tych "gdziekolwiek"
-                    m_aAnywhere[i][2] += neuro_connections; // zwieksz liczbe Connections+Neurons
-                    m_aAnywhere[i][3]++; // zwieksz liczbe Neurons
-                }
-            }
-        }
-    }
-    return 1;
+	// sprawdz zalozenie - o modelach
+	assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
+	assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
+
+	// sprawdz zalozenie - o tablicach
+	assert(m_aDegrees[0] != NULL);
+	assert(m_aDegrees[1] != NULL);
+
+	Part *P1;
+	Joint *J1;
+	int i, j, i2, neuro_connections;
+
+	// dla obu stworzen oblicz liczbe Neurons + connections dla Parts
+	// a takze dla OnJoints i Anywhere
+	for (i = 0; i < 2; i++)
+	{
+		for (j = 0; j < m_Mod[i]->getNeuroCount(); j++)
+		{
+			// pobierz kolejny Neuron
+			Neuro *N = m_Mod[i]->getNeuro(j);
+			// policz liczbe jego wejść i jego samego tez
+			// czy warto w ogole liczyc polaczenia...? co to da/spowoduje?
+			neuro_connections = N->getInputCount() + 1;
+			// wez Part, na ktorym jest Neuron
+			P1 = N->getPart();
+			if (P1)
+			{
+				// dla neuronow osadzonych na Partach
+				i2 = m_Mod[i]->findPart(P1); // znajdz indeks Part w Modelu
+				m_aDegrees[i][i2][2] += neuro_connections; // zwieksz liczbe Connections+Neurons dla tego Part (TDN[2])
+				m_aDegrees[i][i2][3]++; // zwieksz liczbe Neurons dla tego Part (TDN[3])
+			}
+			else
+			{
+				// dla neuronow nie osadzonych na partach
+				J1 = N->getJoint();
+				if (J1)
+				{
+					// dla tych na Jointach
+					m_aOnJoint[i][2] += neuro_connections; // zwieksz liczbe Connections+Neurons
+					m_aOnJoint[i][3]++; // zwieksz liczbe Neurons
+				}
+				else
+				{
+					// dla tych "gdziekolwiek"
+					m_aAnywhere[i][2] += neuro_connections; // zwieksz liczbe Connections+Neurons
+					m_aAnywhere[i][3]++; // zwieksz liczbe Neurons
+				}
+			}
+		}
+	}
+	return 1;
 }
 
 /** Sorts arrays m_aDegrees (for each organism) by Part's degree, and then by
-    number of neural connections and neurons in groups of Parts with the same
-    degree.
-    Assumptions:
-    - Models (m_Mod) are created and available.
-    - Arrays m_aDegrees are created.
-    @saeDegrees, CompareItemNo
- */
+	number of neural connections and neurons in groups of Parts with the same
+	degree.
+	Assumptions:
+	- Models (m_Mod) are created and available.
+	- Arrays m_aDegrees are created.
+	@saeDegrees, CompareItemNo
+	*/
 int ModelSimil::SortPartInfoTables()
 {
-    // sprawdz zalozenie - o modelach
-    assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
-    assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
-
-    // sprawdz zalozenie - o tablicach
-    assert(m_aDegrees[0] != NULL);
-    assert(m_aDegrees[1] != NULL);
-
-    int i;
-    // sortowanie obu tablic wg stopni punktów - TDN[1]
-    if (isFuzzy != 1)
-    {
-        for (i = 0; i < 2; i++)
-        {
-            DB(_PrintDegrees(i));
-            std::qsort(m_aDegrees[i], (size_t) (m_Mod[i]->getPartCount()),
-                       sizeof (TDN), ModelSimil::CompareDegrees);
-            DB(_PrintDegrees(i));
-        }
-    }//sortowanie wg romzmytego stopnia wierzcholka
-
-    else
-    {
-        SortPartInfoFuzzy();
-    }
-
-
-    // sprawdzenie wartosci parametru
-    DB(i = sizeof (TDN);)
-            int degreeType = (isFuzzy == 1) ? FUZZ_DEG : DEGREE;
-
-    // sortowanie obu tablic m_aDegrees wedlug liczby neuronów i
-    // czesci neuronu - ale w obrebie grup o tym samym stopniu
-    for (i = 0; i < 2; i++)
-    {
-        int iPocz = 0;
-        int iDeg, iNewDeg, iPartCount, j;
-        // stopien pierwszego punktu w tablicy Degrees  odniesienie
-        iDeg = m_aDegrees[i][0][degreeType];
-        iPartCount = m_Mod[i]->getPartCount();
-        // po kolei dla kazdego punktu w organizmie
-        for (j = 0; j <= iPartCount; j++)
-        {
-            // sprawdz stopien punktu (lub nadaj 0 - gdy juz koniec tablicy)
-            //			iNewDeg = (j != iPartCount) ? m_aDegrees[i][j][1] : 0;
-            // usunieto stara wersje porownania!!! wprowadzono znak porownania <
-
-            iNewDeg = (j < iPartCount) ? m_aDegrees[i][j][degreeType] : 0;
-            // skoro tablice sa posortowane wg stopni, to mamy na pewno taka kolejnosc
-            assert(iNewDeg <= iDeg);
-            if (iNewDeg != iDeg)
-            {
-                // gdy znaleziono koniec grupy o tym samym stopniu
-                // sortuj po liczbie neuronow w obrebie grupy
-                DB(_PrintDegrees(i));
-                DB(printf("qsort( poczatek=%i, rozmiar=%i, sizeof(TDN)=%i)\n", iPocz, (j - iPocz), sizeof (TDN));)
-                // wyswietlamy z jedna komorka po zakonczeniu tablicy
-                DB(_PrintArray(m_aDegrees[i][iPocz], 0, (j - iPocz)*4);)
-
-                std::qsort(m_aDegrees[i][iPocz], (size_t) (j - iPocz),
-                           sizeof (TDN), ModelSimil::CompareConnsNo);
-                DB(_PrintDegrees(i));
-                // wyswietlamy z jedna komorka po zakonczeniu tablicy
-                DB(_PrintArray(m_aDegrees[i][iPocz], 0, (j - iPocz)*4);)
-                // rozpocznij nowa grupe
-                iPocz = j;
-                iDeg = iNewDeg;
-            }
-        }
-    }
-    return 1;
+	// sprawdz zalozenie - o modelach
+	assert((m_Mod[0] != NULL) && (m_Mod[1] != NULL));
+	assert(m_Mod[0]->isValid() && m_Mod[1]->isValid());
+
+	// sprawdz zalozenie - o tablicach
+	assert(m_aDegrees[0] != NULL);
+	assert(m_aDegrees[1] != NULL);
+
+	int i;
+	// sortowanie obu tablic wg stopni punktów - TDN[1]
+	if (isFuzzy != 1)
+	{
+		for (i = 0; i < 2; i++)
+		{
+			DB(_PrintDegrees(i));
+			std::qsort(m_aDegrees[i], (size_t)(m_Mod[i]->getPartCount()),
+				sizeof(TDN), ModelSimil::CompareDegrees);
+			DB(_PrintDegrees(i));
+		}
+	}//sortowanie wg romzmytego stopnia wierzcholka
+
+	else
+	{
+		SortPartInfoFuzzy();
+	}
+
+
+	// sprawdzenie wartosci parametru
+	DB(i = sizeof(TDN);)
+		int degreeType = (isFuzzy == 1) ? FUZZ_DEG : DEGREE;
+
+	// sortowanie obu tablic m_aDegrees wedlug liczby neuronów i
+	// czesci neuronu - ale w obrebie grup o tym samym stopniu
+	for (i = 0; i < 2; i++)
+	{
+		int iPocz = 0;
+		int iDeg, iNewDeg, iPartCount, j;
+		// stopien pierwszego punktu w tablicy Degrees  odniesienie
+		iDeg = m_aDegrees[i][0][degreeType];
+		iPartCount = m_Mod[i]->getPartCount();
+		// po kolei dla kazdego punktu w organizmie
+		for (j = 0; j <= iPartCount; j++)
+		{
+			// sprawdz stopien punktu (lub nadaj 0 - gdy juz koniec tablicy)
+			//			iNewDeg = (j != iPartCount) ? m_aDegrees[i][j][1] : 0;
+			// usunieto stara wersje porownania!!! wprowadzono znak porownania <
+
+			iNewDeg = (j < iPartCount) ? m_aDegrees[i][j][degreeType] : 0;
+			// skoro tablice sa posortowane wg stopni, to mamy na pewno taka kolejnosc
+			assert(iNewDeg <= iDeg);
+			if (iNewDeg != iDeg)
+			{
+				// gdy znaleziono koniec grupy o tym samym stopniu
+				// sortuj po liczbie neuronow w obrebie grupy
+				DB(_PrintDegrees(i));
+				DB(printf("qsort( poczatek=%i, rozmiar=%i, sizeof(TDN)=%i)\n", iPocz, (j - iPocz), sizeof(TDN));)
+					// wyswietlamy z jedna komorka po zakonczeniu tablicy
+					DB(_PrintArray(m_aDegrees[i][iPocz], 0, (j - iPocz) * 4);)
+
+					std::qsort(m_aDegrees[i][iPocz], (size_t)(j - iPocz),
+					sizeof(TDN), ModelSimil::CompareConnsNo);
+				DB(_PrintDegrees(i));
+				// wyswietlamy z jedna komorka po zakonczeniu tablicy
+				DB(_PrintArray(m_aDegrees[i][iPocz], 0, (j - iPocz) * 4);)
+					// rozpocznij nowa grupe
+					iPocz = j;
+				iDeg = iNewDeg;
+			}
+		}
+	}
+	return 1;
 }
 
